summaryrefslogtreecommitdiff
path: root/build-aux/write-atomic
diff options
context:
space:
mode:
authorLuke Shumaker <lukeshu@sbcglobal.net>2017-01-30 18:42:31 -0500
committerLuke Shumaker <lukeshu@sbcglobal.net>2017-01-30 18:42:31 -0500
commit4f9203808ef9607ae27eba3cf77079bbe661fd95 (patch)
tree4bd6bd4cc388dedbbc74f2b987682b684344f023 /build-aux/write-atomic
parent4abfdaa8c9fa4646f3ba7e9c1bb1f3eb47061f9d (diff)
parent16e8d3b92b5e35a5eaee40a7b7fc0279c342886a (diff)
Merge remote-tracking branch 'autothing/v3/master'
Diffstat (limited to 'build-aux/write-atomic')
-rwxr-xr-xbuild-aux/write-atomic21
1 files changed, 21 insertions, 0 deletions
diff --git a/build-aux/write-atomic b/build-aux/write-atomic
new file mode 100755
index 0000000..ab2a417
--- /dev/null
+++ b/build-aux/write-atomic
@@ -0,0 +1,21 @@
+#!/usr/bin/env bash
+# Copyright (C) 2015-2016 Luke Shumaker
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU Affero General Public License for more details.
+#
+# You should have received a copy of the GNU Affero General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+outfile=$1
+tmpfile="$(dirname "$outfile")/.tmp.${outfile##*/}.tmp"
+
+cat > "$tmpfile" || { r=$?; rm -f "$tmpfile"; exit $r; }
+mv -f "$tmpfile" "$outfile"